Index: configure.ac
===================================================================
--- configure.ac	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ configure.ac	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -38,5 +38,4 @@
 AX_BOOST_BASE([1.40])
 AX_BOOST_PROGRAM_OPTIONS
-#AX_BOOST_FOREACH
 AX_BOOST_FILESYSTEM
 AX_BOOST_THREAD
Index: src/Actions/MapOfActions.cpp
===================================================================
--- src/Actions/MapOfActions.cpp	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/Actions/MapOfActions.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -31,4 +31,5 @@
 #include <boost/optional.hpp>
 #include <boost/program_options.hpp>
+#include <boost/filesystem.hpp>
 
 #include <iostream>
@@ -190,4 +191,20 @@
   BV.zz = boost::lexical_cast<double>(components.at(5));
   v = boost::any(BoxValue(BV));
+}
+
+void validate(boost::any& v, const std::vector<std::string>& values, boost::filesystem::path *, int)
+{
+  boost::filesystem::path filename;
+  std::vector<std::string> components;
+
+  std::cout << "boost::filesystem::path validator used." << std::endl;
+
+  // split comma-separated values
+  if (values.size() != 1) {
+    cerr <<  "Not one file but " << components.size() << " given " << endl;
+    throw boost::program_options::validation_error("Unequal to one file given");
+  }
+  filename = values.at(0);
+  v = boost::any(boost::filesystem::path(filename));
 }
 
@@ -367,5 +384,5 @@
   TypeMap["fill-void"] = &typeid(std::string);
   TypeMap["fragment-mol"] = &typeid(std::string);
-  TypeMap["input"] = &typeid(std::string);
+  TypeMap["input"] = &typeid(boost::filesystem::path);
   TypeMap["linear-interpolate"] = &typeid(std::string);
   TypeMap["molecular-volume"] = &typeid(molecule);
@@ -446,4 +463,5 @@
   TypeEnumMap[&typeid(bool)] = Boolean;
   TypeEnumMap[&typeid(int)] = Integer;
+  TypeEnumMap[&typeid(boost::filesystem::path)] = File;
   TypeEnumMap[&typeid(std::vector<int>)] = ListOfIntegers;
   TypeEnumMap[&typeid(double)] = Double;
@@ -825,4 +843,20 @@
 }
 
+void MapOfActions::queryCurrentValue(const char * name, boost::filesystem::path&_T)
+{
+  std::string tmp;
+  if (typeid( boost::filesystem::path ) == *TypeMap[name]) {
+    if (CurrentValue.find(name) == CurrentValue.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    std::istringstream stream(CurrentValue[name]);
+    CurrentValue.erase(name);
+    if (!stream.fail()) {
+      stream >> tmp >> ws;
+      _T = tmp;
+    }
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
 
 void MapOfActions::setCurrentValue(const char * name, class atom * &_T)
@@ -927,4 +961,14 @@
       stream << (*iter)->getId() << " ";
     }
+    CurrentValue[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void MapOfActions::setCurrentValue(const char * name, boost::filesystem::path &_T)
+{
+  if (typeid( boost::filesystem::path ) == *TypeMap[name]) {
+    std::ostringstream stream;
+    stream << _T.string();
     CurrentValue[name] = stream.str();
   } else
@@ -1051,4 +1095,11 @@
               ;
             break;
+          case File:
+            ListRunner->second->add_options()
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  po::value< boost::filesystem::path >(),
+                  getDescription(*OptionRunner).c_str())
+              ;
+            break;
           case Integer:
             ListRunner->second->add_options()
Index: src/Actions/MapOfActions.hpp
===================================================================
--- src/Actions/MapOfActions.hpp	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/Actions/MapOfActions.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -9,6 +9,7 @@
 #define MAPOFACTIONS_HPP_
 
+#include <boost/filesystem.hpp>
+#include <boost/lexical_cast.hpp>
 #include <boost/program_options.hpp>
-#include <boost/lexical_cast.hpp>
 
 #include <map>
@@ -31,4 +32,5 @@
 
 namespace po = boost::program_options;
+namespace fs = boost::filesystem;
 
 using boost::lexical_cast;
@@ -136,5 +138,5 @@
   friend class MapOfActionsTest;
 public:
-  enum OptionTypes { None, Boolean, Integer, ListOfIntegers, Double, ListOfDoubles, String, ListOfStrings, Vector, ListOfVectors, Box, Molecule, ListOfMolecules, Atom, ListOfAtoms, Element, ListOfElements };
+  enum OptionTypes { None, Boolean, Integer, File, ListOfIntegers, Double, ListOfDoubles, String, ListOfStrings, Vector, ListOfVectors, Box, Molecule, ListOfMolecules, Atom, ListOfAtoms, Element, ListOfElements };
 
   // getter for the action descriptions and short forms
@@ -173,4 +175,5 @@
   void queryCurrentValue(const char * name, std::vector<const element *>&_T);
   void queryCurrentValue(const char * name, std::vector<molecule *>&_T);
+  void queryCurrentValue(const char * name, fs::path&_T);
   template<typename T> void queryCurrentValue(const char * name, T &_T)
   {
@@ -208,4 +211,5 @@
   void setCurrentValue(const char * name, std::vector<const element *>&_T);
   void setCurrentValue(const char * name, std::vector<molecule *>&_T);
+  void setCurrentValue(const char * name, fs::path&_T);
   template<class T> void setCurrentValue(const char * name, T &_T)
   {
Index: src/Actions/WorldAction/InputAction.cpp
===================================================================
--- src/Actions/WorldAction/InputAction.cpp	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/Actions/WorldAction/InputAction.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -30,4 +30,6 @@
 #include <string>
 
+#include <boost/filesystem/fstream.hpp>
+
 using namespace std;
 
@@ -39,41 +41,42 @@
 /** =========== define the function ====================== */
 Action::state_ptr WorldInputAction::performCall() {
-  MoleculeListClass *molecules = World::getInstance().getMolecules();
-  molecule *mol = NULL;
-  std::ifstream test;
+//  MoleculeListClass *molecules = World::getInstance().getMolecules();
+//  molecule *mol = NULL;
+  boost::filesystem::ifstream test;
 
   // obtain information
   getParametersfromValueStorage();
 
-  DoLog(0) && (Log() << Verbose(0) << "Config file given." << endl);
-  if (params.filename.find('.') != string::npos) {
-    std::string FilenamePrefix = params.filename.substr(0,params.filename.find_last_of('.'));
-    std::string FilenameSuffix = params.filename.substr(params.filename.find_last_of('.')+1, params.filename.length());
+  DoLog(0) && (Log() << Verbose(0) << "Config file given " << params.filename << "." << endl);
+  // using the filename as prefix for all parsers
+  std::string FilenameSuffix;
+  std::string FilenamePrefix;
+  if (params.filename.has_filename()) {
+    // get suffix
+    FilenameSuffix = params.filename.extension().substr(1); // remove the prefixed "."
+    FilenamePrefix = params.filename.stem();
     DoLog(1) && (Log() << Verbose(1) << "Setting config file name prefix to " << FilenamePrefix << "." << endl);
-    test.open(params.filename.c_str());
-    if (test == NULL) {
-      DoLog(1) && (Log() << Verbose(1) << "Specified config file " << params.filename << " not found." << endl);
-    } else {
-      DoLog(1) && (Log() << Verbose(1) << "Specified config file found, parsing ... ");
-      FormatParserStorage::getInstance().get((std::istream &)test, FilenameSuffix);
-      test.close();
-    }
     FormatParserStorage::getInstance().SetOutputPrefixForAll(FilenamePrefix);
-    // set mol to first active molecule
-    if (molecules->ListOfMolecules.size() != 0) {
-      for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++)
-        if ((*ListRunner)->ActiveFlag) {
-          mol = *ListRunner;
-          break;
-        }
-    }
-    if (mol == NULL) {
-      mol = World::getInstance().createMolecule();
-      mol->ActiveFlag = true;
-      molecules->insert(mol);
-    }
-    mol->SetNameFromFilename(params.filename.substr(0,params.filename.find('.')).c_str());
   } else {
     DoeLog(1) && (eLog() << Verbose(1) << "Input file does not have a suffix, cannot recognize format." << endl);
+    return Action::failure;
+  }
+
+  // parsing file if present
+  if (!boost::filesystem::exists(params.filename)) {
+    DoLog(1) && (Log() << Verbose(1) << "Specified config file " << params.filename << " not found." << endl);
+    // DONT FAIL: it's just empty and we use the name. // return Action::failure;
+  } else {
+    DoLog(1) && (Log() << Verbose(1) << "Specified config file found, parsing ... ");
+
+    // parse the file
+    test.open(params.filename);
+    FormatParserStorage::getInstance().get(test, FilenameSuffix);
+    test.close();
+
+    // set file name of last molecule
+    MoleculeList::const_iterator iter = World::getInstance().getMolecules()->ListOfMolecules.end();
+    iter--;
+    (*iter)->SetNameFromFilename(FilenamePrefix.c_str());
   }
   return Action::success;
Index: src/Actions/WorldAction/InputAction.def
===================================================================
--- src/Actions/WorldAction/InputAction.def	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/Actions/WorldAction/InputAction.def	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -7,10 +7,10 @@
 
 // all includes and forward declarations necessary for non-integral types below
-
+#include <boost/filesystem.hpp>
 
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
 // "undefine" if no parameters are required
-#define paramtypes (std::string)
+#define paramtypes (boost::filesystem::path)
 #define paramtokens (WorldInputAction::NAME)
 #define paramreferences (filename)
Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/Makefile.am	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -120,23 +120,59 @@
   Thermostats/Woodcock.hpp
 
-QTUIMOC_HEADER = UIElements/QT4/QTDialog.hpp \
-	UIElements/QT4/QTMainWindow.hpp \
-	UIElements/Menu/QT4/QTMenu.hpp \
-	UIElements/Views/QT4/QTWorldView.hpp \
-	UIElements/Views/QT4/GLMoleculeView.hpp \
-	UIElements/Views/QT4/QTMoleculeView.hpp \
-	UIElements/Views/QT4/QTStatusBar.hpp
+QTUIMOC_HEADER = UIElements/Qt4/QtDialog.hpp \
+	UIElements/Qt4/QtMainWindow.hpp \
+	UIElements/Menu/Qt4/QtMenu.hpp \
+	UIElements/Views/Qt4/QtWorldView.hpp \
+	UIElements/Views/Qt4/GLMoleculeView.hpp \
+	UIElements/Views/Qt4/QtMoleculeView.hpp \
+	UIElements/Views/Qt4/QtStatusBar.hpp
 				  
 QTUISOURCE = allmocs.moc.cpp \
-	UIElements/QT4/QTMainWindow.cpp \
-	UIElements/QT4/QTDialog.cpp \
-	UIElements/QT4/QTUIFactory.cpp \
-	UIElements/Menu/QT4/QTMenu.cpp \
-	UIElements/Views/QT4/QTWorldView.cpp \
-	UIElements/Views/QT4/GLMoleculeView.cpp \
-	UIElements/Views/QT4/QTMoleculeView.cpp \
-	UIElements/Views/QT4/QTStatusBar.cpp
+  UIElements/Qt4/Pipe/AtomQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/AtomsQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/BooleanQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/BoxQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/DoubleQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/ElementsQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/EmptyQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/ElementQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/FileQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/IntQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/MoleculeQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/MoleculesQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/StringQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/VectorQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/VectorsQtQueryPipe.cpp \
+  UIElements/Qt4/Query/AtomQtQuery.cpp \
+  UIElements/Qt4/Query/AtomsQtQuery.cpp \
+  UIElements/Qt4/Query/BooleanQtQuery.cpp \
+  UIElements/Qt4/Query/BoxQtQuery.cpp \
+  UIElements/Qt4/Query/DoubleQtQuery.cpp \
+  UIElements/Qt4/Query/DoublesQtQuery.cpp \
+  UIElements/Qt4/Query/ElementQtQuery.cpp \
+  UIElements/Qt4/Query/ElementsQtQuery.cpp \
+  UIElements/Qt4/Query/EmptyQtQuery.cpp \
+  UIElements/Qt4/Query/FileQtQuery.cpp \
+  UIElements/Qt4/Query/IntQtQuery.cpp \
+  UIElements/Qt4/Query/IntsQtQuery.cpp \
+  UIElements/Qt4/Query/MoleculeQtQuery.cpp \
+  UIElements/Qt4/Query/MoleculesQtQuery.cpp \
+  UIElements/Qt4/Query/StringQtQuery.cpp \
+  UIElements/Qt4/Query/StringsQtQuery.cpp \
+  UIElements/Qt4/Query/VectorQtQuery.cpp \
+  UIElements/Qt4/Query/VectorsQtQuery.cpp \
+	UIElements/Qt4/QtMainWindow.cpp \
+	UIElements/Qt4/QtDialog.cpp \
+	UIElements/Qt4/QtUIFactory.cpp \
+	UIElements/Menu/Qt4/QtMenu.cpp \
+	UIElements/Views/Qt4/QtWorldView.cpp \
+	UIElements/Views/Qt4/GLMoleculeView.cpp \
+	UIElements/Views/Qt4/QtMoleculeView.cpp \
+	UIElements/Views/Qt4/QtStatusBar.cpp
              
-QTUIHEADER = ${QTUIMOC_HEADER} UIElements/QT4/QTUIFactory.hpp
+QTUIHEADER = \
+  ${QTUIMOC_HEADER} \
+  UIElements/Qt4/Pipe/QtQueryListPipe.hpp \
+  UIElements/Qt4/QtUIFactory.hpp
 
 QTUI_DEFS =
@@ -289,5 +325,5 @@
 
 
-BOOST_LIB = $(BOOST_LDFLAGS) $(BOOST_MPL_LIB)
+BOOST_LIB = $(BOOST_LDFLAGS) $(BOOST_MPL_LIB) $(BOOST_PROGRAM_OPTIONS_LIB) $(BOOST_FILESYSTEM_LIB) $(BOOST_THREAD_LIB)
 GUI_LIBS = ${QT_LDADD} ${QT_LIB_GUI} -lQtOpenGL ${GLU_LIBS}
 INCLUDES = -I$(top_srcdir)/src/unittests -I$(top_srcdir)/src/Actions -I$(top_srcdir)/src/UIElements
@@ -315,10 +351,7 @@
 	Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
 	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
-	$(BOOST_LIB) \
-	${BOOST_THREAD_LIB} \
-	${BOOST_PROGRAM_OPTIONS_LIB}
-
-
-#Stuff for building the GUI using QT
+	$(BOOST_LIB)
+
+#Stuff for building the GUI using Qt
 molecuildergui_SOURCES = ${QTUISOURCE} builder.cpp
 molecuildergui_CXXFLAGS = ${QT_CXXFLAGS} ${GLU_CXXFLAGS} -DUSE_GUI_QT
@@ -326,5 +359,5 @@
 
 unity_SOURCES = unity.cpp
-unity_LDADD = $(BOOST_LIB) ${BOOST_THREAD_LIB} ${BOOST_PROGRAM_OPTIONS_LIB}
+unity_LDADD = $(BOOST_LIB)
 
 molecuildergui_LDADD = \
@@ -337,6 +370,4 @@
 	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
 	$(BOOST_LIB) \
-	${BOOST_THREAD_LIB} \
-	${BOOST_PROGRAM_OPTIONS_LIB} \
 	${GUI_LIBS}
 
@@ -350,7 +381,5 @@
 	Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
 	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
-	$(BOOST_LIB) \
-	${BOOST_THREAD_LIB} \
-	${BOOST_PROGRAM_OPTIONS_LIB}
+	$(BOOST_LIB)
 
 analyzer_SOURCES = analyzer.cpp datacreator.cpp periodentafel.hpp datacreator.hpp 
@@ -363,9 +392,7 @@
 	Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
 	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
-	$(BOOST_LIB) \
-	${BOOST_THREAD_LIB} \
-	${BOOST_PROGRAM_OPTIONS_LIB}
-
-#Rules needed for QT4
+	$(BOOST_LIB)
+
+#Rules needed for Qt4
 # UI-Files are scattered throughout several subdirectories
 # Therfore `%'-rules do not seem to work
Index: src/Parser/MpqcParser.cpp
===================================================================
--- src/Parser/MpqcParser.cpp	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/Parser/MpqcParser.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -49,5 +49,6 @@
 void MpqcParser::load(istream *file)
 {
-  DoeLog(0) && (Log() << Verbose(0) << "Not yet implemented" << endl) ;
+  // TODO: MpqcParser::load implementation
+  ASSERT(false, "Not implemented yet");
 }
 
Index: src/Parser/PcpParser.cpp
===================================================================
--- src/Parser/PcpParser.cpp	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/Parser/PcpParser.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -355,10 +355,8 @@
   // 3. parse the molecule in
   molecule *mol = World::getInstance().createMolecule();
-  MoleculeListClass *molecules = World::getInstance().getMolecules();
-  molecules->insert(mol);
+  mol->ActiveFlag = true;
+  // TODO: Remove the insertion into molecule when saving does not depend on them anymore. Also, remove molecule.hpp include
+  World::getInstance().getMolecules()->insert(mol);
   LoadMolecule(mol, FileBuffer, World::getInstance().getPeriode(), FastParsing);
-  //mol->SetNameFromFilename(filename);
-  mol->ActiveFlag = true;
-  //MolList->insert(mol);
 
   // 4. dissect the molecule into connected subgraphs
Index: src/Parser/PdbParser.cpp
===================================================================
--- src/Parser/PdbParser.cpp	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/Parser/PdbParser.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -74,4 +74,6 @@
  */
 void PdbParser::load(istream* file) {
+  // TODO: PdbParser::load implementation
+  ASSERT(false, "Not implemented yet");
 //  string line;
 //  string::size_type location;
@@ -132,6 +134,6 @@
       elementNo[Z] = (elementNo[Z]+1) % 100;   // confine to two digits
       const molecule *mol = (*atomIt)->getMolecule();
-      if (mol == NULL) {  // for homeless atoms, MolNo = 0 is reserved
-        MolNo = 0;
+      if (mol == NULL) {  // for homeless atoms, MolNo = -1 is reserved
+        MolNo = -1;
       } else {
         MolNo = mol->getId();
Index: src/Parser/TremoloParser.cpp
===================================================================
--- src/Parser/TremoloParser.cpp	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/Parser/TremoloParser.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -92,4 +92,7 @@
   usedFields.clear();
   molecule *newmol = World::getInstance().createMolecule();
+  newmol->ActiveFlag = true;
+  // TODO: Remove the insertion into molecule when saving does not depend on them anymore. Also, remove molecule.hpp include
+  World::getInstance().getMolecules()->insert(newmol);
   while (file->good()) {
     std::getline(*file, line, '\n');
